// ============================================================================
//	CN[h
// ============================================================================

#include <stdio.h>
#include <stdlib.h>

#include <GL/glut.h>

#include <AR/config.h>
#include <AR/video.h>
#include <AR/param.h>
#include <AR/ar.h>
#include <AR/gsub_lite.h>

#include "controller.h"	// L[{[hɂ鑀
#include "GLMetaseq.h"	// MQO[_


// ============================================================================
//	Cu
// ============================================================================

#ifdef _DEBUG
	#pragma comment(lib,"libARd.lib")
	#pragma comment(lib,"libARgsubd.lib")
	#pragma comment(lib,"libARvideod.lib")
	#pragma comment(lib,"libARgsub_lited.lib")
	#pragma comment(linker,"/NODEFAULTLIB:libcmtd.lib")
#else
	#pragma comment(lib,"libAR.lib")
	#pragma comment(lib,"libARgsub.lib")
	#pragma comment(lib,"libARvideo.lib")
	#pragma comment(lib,"libARgsub_lite.lib")
	#pragma comment(linker,"/NODEFAULTLIB:libcmt.lib")
#endif


// ============================================================================
//	^`
// ============================================================================

// LN^f[^\
typedef struct {
	MQO_MODEL	model;
	GLfloat		rot;
	GLfloat		x;
	GLfloat		y;
	GLfloat		z;
	int			pattId;
	int			patt_found;
	double		trans[3][4];
} CHARACTER_DATA;


// ============================================================================
//	O[oϐ
// ============================================================================

// 萔
#define NUM_MODEL	2
#define SACCHI		0
#define JINJA		1

// TRUEFEBhE[h^FALSEFtXN[[h
static const int gWindowed = TRUE;

// tXN[[h̐ݒ
static const int gFullWidth    = 800;	// ʉ𑜓x
static const int gFullHeight   = 600;	// ʉ𑜓x
static const int gFullDepth    = 32;	// rbg
static const int gFullRefresh  = 0;		// tbV[gD0ŃftHglD

// E^zẼXP[t@N^
static const double gViewScaleFactor = 1.0;

// E͈̔́iMin`Max܂ł͈̔͂ɂIuWFNg`j
static const double gViewDistanceMin = 0.1;
static const double gViewDistanceMax = 10000.0; 

static char *gCparamName = "Data/camera_para.dat";		// Jp[^t@C
static char *gVconf      = "Data/WDM_camera_flipV.xml";	// rfIfoCX̐ݒt@C
static char *gModelName[2] = { "Data/sacchi.mqo", "Data/domain.mqo" };	// ft@C
static char *gPattName[2] = { "Data/patt.sacchi", "Data/patt.jinja" };	// p^[t@C

static double	gJinja_radius = 50.0;	// ǗOhC̔a
static double	gSacchi_radius = 40.0;	// Tb`[̔aij

static ARUint8	*gARTImage     = NULL;	// J摜ւ̃|C^
static int		gARTThreshhold = 100;	// 2l臒l

static double	gPatt_width     = 80.0;			// p^[̃TCYimmPʁj
static double	gPatt_centre[2] = {0.0, 0.0};	// p^[̒SʒuimmPʁj

static ARParam						gARTCparam;				// Jp[^
static ARGL_CONTEXT_SETTINGS_REF	gArglSettings = NULL;	// `n̐ݒ

// LN^̃f[^
static CHARACTER_DATA	gCharacter[2];

// VF[fBOON/OFF
static int gLight_on = TRUE;


// ============================================================================
// J̃ZbgAbv֐
// ============================================================================
static int SetupCamera( const char *cparam_name, char *vconf, ARParam *cparam )
{	
    ARParam		wparam;			// Jp[^iƗpϐj
	int			xsize, ysize;	// 摜TCY

	// rfIfoCXJ
    if ( arVideoOpen( vconf ) < 0 ) {
		printf( "J܂\n" );
		return FALSE;
	}
	
    // 摜̃TCY擾
	if ( arVideoInqSize( &xsize, &ysize ) < 0 ) {
		printf( "摜TCY̎擾Ɏs܂\n" );
		return FALSE;
	}

	// Jp[^̃[hCl̏CƏ
	if ( arParamLoad( cparam_name, 1, &wparam ) < 0 ) {
		printf( "Jp[^t@C̃[hɎs܂\n" );
        return FALSE;
    }
    arParamChangeSize( &wparam, xsize, ysize, cparam );
    arInitCparam( cparam );

	// rfILv`̃X^[g
	if ( arVideoCapStart() != 0 ) {
		printf( "rfILv`̃X^[gɎs܂\n" );
		return FALSE;
	}
	
	return TRUE;
}


// ============================================================================
// }[J̃ZbgAbv֐
// ============================================================================
static int SetupMarker( const char *patt_name, int *patt_id )
{
	// }[J̃[h
    if ( ( *patt_id = arLoadPatt( patt_name ) ) < 0 ) {
		printf( "p^[t@C̃[hɎs܂\n" );
        return FALSE;
    }
	
	return TRUE;
}


// ============================================================================
// `ñZbgAbv֐iEBhEj
// ============================================================================
static int SetupGraphicsWin( const char *title, int dispWidth, int dispHeight )
{
	// fBXvC[h̐ݒ
	glutInitDisplayMode( GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH );

	// EBhE̐ݒ
	glutInitWindowSize( dispWidth, dispHeight );
	glutCreateWindow( title );

	// gsub_lite Cȕ
	if ( ( gArglSettings = arglSetupForCurrentContext() ) == NULL ) {
		return FALSE;
	}

	return TRUE;
}


// ============================================================================
// `ñZbgAbv֐itXN[j
// ============================================================================
static int SetupGraphicsFull( int dispWidth, int dispHeight, int dispDepth, int dispRefresh )
{
	char glutGamemode[32];

	// fBXvC[h̐ݒ
	glutInitDisplayMode( GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH );

	// tXN[̐ݒ
	if ( dispRefresh ) {
		sprintf( glutGamemode, "%ix%i:%i@%i", dispWidth, dispHeight, dispDepth, dispRefresh );
	} else {
		sprintf( glutGamemode, "%ix%i:%i", dispWidth, dispHeight, dispDepth );
	}
	glutGameModeString( glutGamemode );
	glutEnterGameMode();

	// gsub_lite Cȕ
	if ( ( gArglSettings = arglSetupForCurrentContext() ) == NULL ) {
		return FALSE;
	}

	return TRUE;
}


// ============================================================================
// I֐
// ============================================================================
static void Quit( void )
{
	int i;

	arVideoCapStop();				// rfILv`̒~
	arVideoClose();					// rfIfoCX
	arglCleanup( gArglSettings );	// `n̏I

	for (i=0; i<NUM_MODEL; i++) {
		mqoDeleteModel( gCharacter[i].model );	// f̍폜
	}
	mqoCleanup();	// GLMetaseq̏I
}


// ============================================================================
// ACh֐
// ============================================================================
static void Idle( void )
{
	static int ms_prev;		// O̎
	int ms;					// ݂̎
	float s_elapsed;		// oߎ
	ARUint8 *image;			// 摜

	ARMarkerInfo	*marker_info;	// }[J
    int				marker_num;		// oꂽ}[J̐
	int				i, j, k;


	// ǑĂяǒoߎԂvCXV100HzȉɂȂ悤ɂ
	ms = glutGet( GLUT_ELAPSED_TIME );
	s_elapsed = (float)( ms - ms_prev ) * 0.001;
	if ( s_elapsed < 0.01f ) return;
	ms_prev = ms;


	// J摜̎擾
	if ( ( image = arVideoGetImage() ) != NULL ) {

		// 摜ւ̃|C^擾
		gARTImage = image;		
		
		// }[J̌oԂ
		for (i=0; i<NUM_MODEL; i++) gCharacter[i].patt_found = FALSE;

		// }[J̌o
		if ( arDetectMarker( gARTImage, gARTThreshhold, &marker_info, &marker_num ) < 0 ) {
			exit(0);
		}

		for (i=0; i<NUM_MODEL; i++) {
			// łMx̍}[JT
			k = -1;
			for ( j = 0; j < marker_num; j++ ) {
				if ( marker_info[j].id == gCharacter[i].pattId ) {
					if ( k == -1 ) k = j;
					else if( marker_info[j].cf > marker_info[k].cf ) k = j;
				}
			}

			// łvx̍}[J(k)ɑ΂čWϊs߂
			if ( k != -1 ) {
				arGetTransMat( &( marker_info[k] ), gPatt_centre, gPatt_width, gCharacter[i].trans );
				gCharacter[i].patt_found = TRUE;
			}
		}
	
		// ʂ̕`w
		glutPostRedisplay();
	}

}


// ============================================================================
// EBhẺ`FbN֐
// ============================================================================
static void Visibility( int visible )
{
	// EBhEĂȂƂ̓ACh֐𖳌ɂ
	if ( visible == GLUT_VISIBLE ) {
		glutIdleFunc( Idle );
	} else {
		glutIdleFunc( NULL );
	}
}


// ============================================================================
// EBhETCYύXꂽƂɌĂ΂֐
// ============================================================================
static void Reshape( int w, int h )
{
	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
	glViewport( 0, 0, (GLsizei) w, (GLsizei) h );
	
	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();
	glMatrixMode( GL_MODELVIEW );
	glLoadIdentity();
}


// ============================================================================
// ݒ肷֐
// ============================================================================
static void SetLight( GLenum light )
{
	GLfloat light_diffuse[]  = { 0.9, 0.9, 0.9, 1.0 };	// gUˌ
	GLfloat light_specular[] = { 1.0, 1.0, 1.0, 1.0 };	// ʔˌ
	GLfloat light_ambient[]  = { 0.3, 0.3, 0.3, 0.1 };	// 
	GLfloat light_position[] = { 0.0, 0.0, 0.0, 1.0 };	// ʒuƎ

	// ̐ݒ
	glLightfv( light, GL_DIFFUSE,  light_diffuse );	 // gUˌ̐ݒ
	glLightfv( light, GL_SPECULAR, light_specular ); // ʔˌ̐ݒ
	glLightfv( light, GL_AMBIENT,  light_ambient );	 // ̐ݒ
	glLightfv( light, GL_POSITION, light_position ); // ʒuƎނ̐ݒ

	glEnable( light );	// ̗L
}


// ============================================================================
// Tb`[̏ԂvZ֐
// ============================================================================
static void CalcState(void)
{
	CONTROLLER_DATA	control;	// Rg[iL[{[hj
	static GLfloat v = 0;		// is̑x
	double inv_trans[3][4];		// ts
	double trans[3][4];			// }[JԂ̕ϊs
	double jx,jy,jz;			// Tb`[ɑ΂_Ђ̈ʒu
	double distance;			// _ЁETb`[ԋ
	int    touch;				// ڐG

	// Tb`[ĂȂƂ͏LZ
	if ( !gCharacter[SACCHI].patt_found ) return 0;

	// Rg[̃f[^擾
	GetControllerData( &control );

	// ƌ
	if ( control.up == KEY_DOWN ) {
		// ɉ
		v = 20;
	} else if ( control.down  == KEY_DOWN ) { 
		// tɉ
		v = -20;
	} else {
		// 
		if (v>0) { v--; }
		else if (v<0) { v++; }
	}

	// ]
	if ( control.right == KEY_DOWN ) { gCharacter[SACCHI].rot -= 20.0; }
	if ( control.left  == KEY_DOWN ) { gCharacter[SACCHI].rot += 20.0; }

	// ړ
	gCharacter[SACCHI].x +=  v * sin(gCharacter[SACCHI].rot*3.14/180);
	gCharacter[SACCHI].y += -v * cos(gCharacter[SACCHI].rot*3.14/180);


	// _ЂĂƂ̓Tb`[E_ЊԂ̋𑪂ĐڐG
	if ( gCharacter[JINJA].patt_found ) {

		arUtilMatInv( gCharacter[SACCHI].trans, inv_trans );
		arUtilMatMul( inv_trans, gCharacter[JINJA].trans, trans );

		// Tb`[}[JWnł̐_Ђ̈ʒu
		jx = trans[0][3];
		jy = trans[1][3];
		jz = trans[2][3];

		// Tb`[E_ЊԂ̋
		distance = sqrt( (jx - gCharacter[SACCHI].x)*(jx - gCharacter[SACCHI].x) +
						 (jy - gCharacter[SACCHI].y)*(jy - gCharacter[SACCHI].y) +
						 (jz - gCharacter[SACCHI].z)*(jz - gCharacter[SACCHI].z) 
					    );

		// ڐG
		touch = ( distance <= gJinja_radius + gSacchi_radius );
	} else {
		touch = FALSE;
	}

	// ڐGĂȂ悤ɂ
	if (touch) {
		v = -v;
		gCharacter[SACCHI].x +=  v * sin(gCharacter[SACCHI].rot*3.14/180);
		gCharacter[SACCHI].y += -v * cos(gCharacter[SACCHI].rot*3.14/180);
		v = 0;
	}

	// ʒuɃZbg
	if ( control.B == KEY_DOWN ) {
		gCharacter[SACCHI].rot = 0;
		gCharacter[SACCHI].x = 0;
		gCharacter[SACCHI].y = 0;
		gCharacter[SACCHI].z = 0;
	}

	if ( control.A == KEY_DOWN ) gLight_on = TRUE;
	if ( control.C == KEY_DOWN ) gLight_on = FALSE;

}


// ============================================================================
// fBXvC֐
// ============================================================================
static void Display( void )
{
    GLdouble p[16];	// ˉeϊs
	GLdouble m[16];	// Wϊs
	int i;

	glDrawBuffer( GL_BACK );								// obNobt@ɕ`
	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );	// obt@̏
	
	// J摜̕`
	arglDispImage( gARTImage, &gARTCparam, 1.0, gArglSettings );	// zoom = 1.0.

	// t[̃Lv`w
	arVideoCapNext();
	gARTImage = NULL;

	// IuWFNg̏ԂvZ
	CalcState();

	// ˉeϊs̓Kp
	arglCameraFrustumRH( &gARTCparam, gViewDistanceMin, gViewDistanceMax, p );
	glMatrixMode( GL_PROJECTION );
	glLoadMatrixd( p );

	// fr[s̏
	glMatrixMode( GL_MODELVIEW );
	glLoadIdentity();

	glClear( GL_DEPTH_BUFFER_BIT );			// Zobt@̏
	glEnable( GL_DEPTH_TEST );				// Bʏ̓Kp

	// ̐ݒi_ɑ΂ČŒj
	glPushMatrix();
		SetLight( GL_LIGHT0 );
	glPopMatrix();

	// VF[fBOON/OFF
	if (gLight_on) {
		glEnable( GL_LIGHTING );
	} else {
		glDisable( GL_LIGHTING );
	}

	// `R[h
	for (i=0; i<NUM_MODEL; i++) {

		if ( gCharacter[i].patt_found ) {

			glPushMatrix();
				// Wϊs̓Kp
				arglCameraViewRH( gCharacter[i].trans, m, gViewScaleFactor );
				glLoadMatrixd( m );

				glPushMatrix();
					glTranslatef( gCharacter[i].x, gCharacter[i].y, gCharacter[i].z ) ;	// f̈ʒu
					glRotatef( gCharacter[i].rot, 0.0, 0.0, 1.0 );	// f̌
					glRotatef( 90.0, 1.0, 0.0, 0.0 );				// f𗧂
					mqoCallModel( gCharacter[i].model );			// f̕`
				glPopMatrix();

			glPopMatrix();
		}

	}

	glDisable( GL_LIGHTING );
	glDisable( GL_DEPTH_TEST );

	glutSwapBuffers();	// obt@̔]
}


// ============================================================================
// main֐
// ============================================================================
int main( int argc, char** argv )
{
	int i;

	// GLUT̏
	glutInit( &argc, argv );

	// J̃ZbgAbv
	if ( !SetupCamera( gCparamName, gVconf, &gARTCparam ) ) return 0;

	// }[J̃ZbgAbv
	for (i=0; i<NUM_MODEL; i++) {
		if ( !SetupMarker( gPattName[i], &(gCharacter[i].pattId) ) ) return 0;
	}

	// `ñZbgAbv
	if ( gWindowed ) {
		if ( !SetupGraphicsWin( "Tb`[ on ARToolKit", arImXsize, arImYsize ) ) return 0;
	} else {
		if ( !SetupGraphicsFull( gFullWidth, gFullHeight, gFullDepth, gFullRefresh ) ) return 0;
	}

	// GLMetaseq̏
	mqoInit();

	// f̓ǂݍ
	for (i=0; i<NUM_MODEL; i++) {
		if ( ( gCharacter[i].model = mqoCreateModel( gModelName[i], 1.0 ) ) == NULL ) {
			printf( "f̓ǂݍ݂Ɏs܂" );
			return 0;
		}
	}

	// LN^̃f[^̏
	for (i=0; i<NUM_MODEL; i++) {
		gCharacter[i].patt_found = FALSE;
		gCharacter[i].rot = 0.0;
		gCharacter[i].x   = 0.0;
		gCharacter[i].y   = 0.0;
		gCharacter[i].z   = 0.0;
	}

	// IɌĂ΂֐̐ݒ
	atexit( Quit );

	// R[obN֐̐ݒ
	glutDisplayFunc( Display );
	glutReshapeFunc( Reshape );
	glutVisibilityFunc( Visibility );
	glutKeyboardFunc( KeyDown );
	glutKeyboardUpFunc( KeyUp );
	glutSpecialFunc( SpecialKeyDown );
	glutSpecialUpFunc( SpecialKeyUp );

	printf("<<@>>\n");
	printf("L[ : ړ\n");
	printf("   %c     : ʒuɃZbg\n", KEY_B);
	printf("   %c     : VF[fBOOn\n", KEY_A);
	printf("   %c     : VF[fBOOff\n", KEY_C);
	printf("  ESC    : I\n");

	glutMainLoop();

	return 0;
}
